Subject: [rohc] RE: List Compression

From: "Shweta Dass" <[email-masked]>
Date: Tue, 16 Oct 2007 10:31:26 +0530

Hi,

Thanks for the reply.

Regarding the first doubt, I wanted to know what will be the 'next
header' field exactly contain when an uncompressed header is sent as a
part of 
i) Generic list 
ii) To be inserted in a list (Insert only scheme)

There are 2 understandings  I could have from the spec:

1)As per my understanding of the section 5.8.4.4 (related to GRE), it
seems that 'Next Header' value will be
 
i)Generic list: The value corresponding to actual subsequent header 
ii)Insert only Scheme: The value corresponding to the header itself 

But in such cases, how is the extension header just following the IP in
dynamic chain known for generic list??

Considering the following example, - IP/AH/UDP/RTP, how is it known that
AH follows IP in the extension header list( for generic list case) since
the 'Next Header' field of AH will have UDP (as per above understanding)

2) Assuming the above understanding is wrong, second approach can be
that 'Next Header' of an uncompressed header always contains value
corresponding to itself and never the subsequent header. In such case
why the name 'Next Header' ??? Also, this implies Generic list has to
contain items of the list in the ordered fashion.

Please clarify.

Thanks
Regards
Shweta

-----Original Message-----
From: [email-masked]
[mailto:[email-masked]] 
Sent: Monday, October 15, 2007 7:40 PM
To: Shweta Dass
Subject: List Compression

Hi,
 
Regarding your 2nd doubt on how to identify the presence of extension
header list at the decompressor:
 Refer section 5.8.5.1  of RFC 3095
   if generic list present the first octet shall be 80 or some other
value
   if no list then it shall be zero.

This is the only way decompressor could identify.

I am not able to understand your 1st doubt.

Regards,
Mallikarjuna.H.B
Shweta Dass wrote:
> 
> Hi,
>  
> Post as found at
> http://www1.ietf.org/mail-archive/web/rohc/current/msg01604.html
>  
> Vishal,
>  
>> Considering a scenario where we have an IP stream - IP/AH/UDP/RTP.
>> (snip)
>> In static list the next header field in IP header will point to UDP ,
>> And therefore there is no way to determine which extension header is
>> present
>> in "Generic extension header list".
>  
> See following text from Section 5.8.4.1 of RFC 3095 (I know we could
> have done a better job to make the document more readable...)
>  
>    All communicated uncompressed extension header items indicate their
>    own type in their Next Header field.
>  
>  
>  
> Referring to the above post at 
>  
> http://www1.ietf.org/mail-archive/web/rohc/current/msg01604.html
>  
> 1)I had query relating to following text mentioned in the section
> 5.8.4.4 
> 
>  
> 
>    A one-octet Next Header field is inserted as the first octet of the
> header.  
> 
>    The value of the Next Header field corresponds to GRE (this value
is
> 47
> 
>    according to the Assigned Internet Protocol Number section of
> 
>    [ASSIGNED]) when the uncompressed item is to be inserted in a list,
> 
>    and to the type of the subsequent header when the uncompressed item
> 
>    is in a Generic list.
>  
>  
> As per the above text, it is clear that when an uncompressed item is
> part of a generic list (which will be typically the scenario in case
of
> IR and IR-DYN packets), next header field will correspond to the
> subsequent header and if that is the case, then there is no way to
> determine the first extension header present in "Generic extension
> header list".
>  
> Assuming that the header items of generic list also indicate their own
> types in their next header field (as stated above),does that mean the
> generic lists are ordered lists??
>  
> 2) Also, wanted to know how is the presence of extension header list
in
> the dynamic chain detected??
>  
>   Considering the above example of IP/AH/UDP/RTP,
>  
> For an IR packet, 
>  
>  static chain  : IP(Static part),UDP(static part) and RTP(static part)
>  dynamic chain : IP(Dynamic part including IP Generic Extension header
> list) followed by UDP checksum (UDP dynamic part) and then RTP
Sequence
> number (RTP dynamic part).... Now how does de-compressor detect that
IP
> Dynamic part contains the "Generic extension header list" part or
not???
> 
> 
> 
> 
>  
> 
> 
> _______________________________________________
> Rohc mailing list
> [email-masked]
> https://www1.ietf.org/mailman/listinfo/rohc
> 
> 
Quoted from: 
http://www.nabble.com/List-Compression-tf4625054.html#a13208275

_______________________________________________
Rohc mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/rohc

---

From: Biplab Sarkar <[email-masked]>
Date: Tue, 16 Oct 2007 11:05:04 +0530

Shweta,

Check  RFC3095[5.8.4] for the concept of index in IP headers.

Thanks
Biplab

---

From: Carl Knutsson <[email-masked]>
Date: Tue, 16 Oct 2007 11:37:44 +0200

Shweta,

I cannot see any need for additions or clarifications to RFC3095
regarding this issue. Please read the section 5.8 and 5.8.4 more carefully.

The text you are referring to in section 5.8.4.4, specifies that
"Assigned Internet Protocol Numbers" should be used instead of "Ether
Protocol Numbers" in uncompressed list items following a GRE
uncompressed item.

Section 5.8.4.1 still applies for the next header field in GRE
uncompressed list items.

/Carl Knutsson